{
     "openapi": "3.0.1",
     "info": {
          "title": "Synapse REST API",
          "version": "v1"
     },
     "servers": [{"url": "https://repo-prod.prod.sagebase.org"}],
     "tags": [
          {
               "name": "Access Approval Services",
               "description": "The Access Approval services manage the fulfillment of Access Requirements, on a per-user basis.  \n (See <a href=\"#org.sagebionetworks.repo.web.controller.AccessRequirementController\">\n Access Requirement Services<\/a> for more information.)  Most of the Access Approval services\n are available only to members of the Synapse Access and Compliance Team (ACT)."
          },
          {
               "name": "Access Requirement Services",
               "description": "These services manage the Access Requirements/Restrictions (ARs) which may be placed on Entities,\n or Teams.  An Access Requirement specifies the type of access being restricted as well\n as how the requirement is fulfilled. \n <p>\n ARs complement Access Control Lists (ACLs) for managing access to Synapse objects.\n While ACLs are managed by entity owners, ARs are managed by the Synapse Access and Compliance Team (ACT), which is\n responsible for governance of sensitive data.  Before one may access data associated with an \n AR, there must be a corresponding Access Approval.  For certain ARs --\n of the \"self-sign\" variety -- one may grant ones own approval by agreeing to associated\n 'terms of use.'  For other Access Requirements -- of the 'ACT' variety -- approval may be granted\n only by the ACT.\n <\/p>\n <p>\n As stated above, an AR specifies the type of access being controlled.  Generally\n entities are restricted with DOWNLOAD access.  A Synapse user may be able to see that a Synapse\n File exists, but be unable to download the content due to such an AR.  Teams are\n restricted using the PARTICIPATE access type:  Prior to joining a Team a user must fulfill any\n associated ARs controlling this type of access.\n <\/p>\n <p>\n Entity ARs are inherited from ancestors.  E.g. an AR applied to a Folder will control all Files in the Folder, \n or within sub-folders of the Folder.  Access Requirements are cumulative:  A File will be controlled both\n by ARs applied to it directly and by ARs applied to any and all of its ancestors.\n <\/p>\n <p>\n Access Requirements are fulfilled on a per-user basis using the <a href=\"#org.sagebionetworks.repo.web.controller.AccessApprovalController\">\n Access Approval Services<\/a>.\n <\/p>"
          },
          {
               "name": "Activity Services",
               "description": "<p>\n The <a href=\"${org.sagebionetworks.repo.model.provenance.Activity}\">Activity<\/a>\n model represents the main record of Provenance in Synapse. It is analygous to\n the Activity defined in the <a href=\"http://www.w3.org/TR/prov-primer/\">W3C\n Specification on Provenance<\/a>.\n <\/p>\n <h6>Used & Generated By<\/h6>\n <p>\n Used links are stored directly in the Activity model object as an array of <a href=\"${org.sagebionetworks.repo.model.provenance.Used}\">Used<\/a> objects.\n There is a flag in <a href=\"${org.sagebionetworks.repo.model.provenance.Used}\">Used<\/a> that marks\n if it was \"executed\". <a href=\"${org.sagebionetworks.repo.model.provenance.Used}\">Used<\/a> is an\n interface that is implemented by two objects:\n <\/p>\n <ul>\n <li><a href=\"${org.sagebionetworks.repo.model.provenance.UsedEntity}\">UsedEntity<\/a>\n - For referencing <a href=\"${org.sagebionetworks.repo.model.Entity}\">Entities<\/a> already stored\n in Synapse<\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.provenance.UsedURL}\">UsedURL<\/a> - For\n referencing URL-accessed resources stored outside of Synapse. In Provenance\n visualizations, some URLs are given a special icon, such as links to <a href=\"https://github.com/\">GitHub<\/a>. Note: it is also possible to wrap a\n URL with a <a href=\"${org.sagebionetworks.repo.model.FileEntity}\">FileEntity<\/a> if you\n want all the resources that come with Synapse entities.<\/li>\n <\/ul>\n <p>\n wasGeneratedBy links are stored for each version of each Entity. Thus you\n update the entity with the activity id that generated it. You can ask the\n entity service which activity generated it, and conversely you can ask the\n activity service what entity versions were generatedBy a given activity.\n <\/p>\n <h6>Access Control for Activities<\/h6>\n <p>\n Access to <a href=\"${org.sagebionetworks.repo.model.provenance.Activity}\">Activity<\/a>\n objects is dictated by the following rules:\n <ul>\n <li><b>READ<\/b> - Granted to those users who can see a single Entity that was\n generated by this Activity.<\/li>\n <li><b>UPDATE/DELETE<\/b> - You must be the creator of the Activity to modify\n or delete it.<\/li>\n <li><b>Setting generatedBy for an Entity<\/b> (see <a href=\"${POST.entity}\">POST\n /entity<\/a>) - You must be the creator of the activity to connect it to\n an Entity. (The Entity services allow you to specify an activityId that\n creates a generatedBy relationship between an Activity and an Entity.)<\/li>\n <\/ul>\n \n <\/p>"
          },
          {
               "name": "Agent Chat Services",
               "description": "The Synapse chat services allow the user to chat with a 'bot' (agent) that\n has access to Synapse data. By default, Synapse provides a 'baseline' agent\n that has basic access to all of the supported Synapse action group functions\n and knowledge bases. Sage authorized collaborators can create their own\n agents that can also utilize the same action groups and knowledge bases used\n by the baseline agent. The collaborator's agent can then be used to override\n the baseline agent for chat sessions.\n <\/p>\n To get started, the first step is to create a new session by calling:\n <a href=\"${POST.agent.session}\">POST /agent/session<\/a>. You will need the\n sessionId from the resulting <a href=\"${org.sagebionetworks.repo.model.agent.AgentSession}\">AgentSession<\/a>. The\n sessionId uniquely identifies a single conversation between the user and the\n agent. Specifically, the session contains user's chat requests, agent\n responses and all of the data gathered by the agent to meet user requests.\n The session data is the context provided to the Large Language Model (LLM)\n used by the agent. Only the user that create a session will have access to\n its data and be able to use it for an agent conversation.\n <\/p>\n The user's conversation with an agent is a series of asynchronous jobs under\n the provided sessionId, where each job is started by providing the user's\n prompt to the agent. The job's response will then include the agent's\n response to the user's prompt. Use:\n <a href=\"POST.agent.chat.async.start\">POST /agent/chat/async/start<\/a> to\n start a chat job and <a href=\"GET.agent.chat.async.get.asyncToken\">GET\n /agent/chat/async/get/{asyncToken}<\/a> to get the job's results."
          },
          {
               "name": "Asynchronous Job Services",
               "description": "This is a generic set of services that provides support for both launching\n asynchronous jobs and monitoring the progress of jobs."
          },
          {
               "name": "Authentication Services",
               "description": "<p>\n Provides REST APIs for managing and obtaining the necessary credentials to access Synapse.\n <\/p>\n <p>\n Authentication to Synapse services requires an access token passed in the HTTP Authorization\n header, as per the <a href=\"https://tools.ietf.org/html/rfc6750#section-2.1\">HTTP bearer authorization<\/a> standard.\n The access token incorporates a set of 'scopes' and the documentation for each service requiring \n authorization lists the scopes which the access token must include in order to use that service.\n <p/>\n <p>\n Synapse currently supports four modes of obtaining an access token:\n <\/p>\n <ul>\n <li>Present username and password<\/li>\n <li>Authentication via a whitelisted OAuth 2.0 provider<\/li>\n <li>Authentication via a registered OAuth 2.0 client<\/li>\n <li>Exchange an access token for Personal Access Token<\/li>\n <\/ul>\n <p>\n The username and password are exchanged for an access token \n using <a href=\"${POST.login2}\">POST /login2<\/a> service.\n This method should only be used by Synapse itself.  No other \n application should prompt a user for their user name and password.\n <\/p>\n <p>\n Synapse allows authentication via a white listed OAuth 2.0 provider.  Currently only Google is supported.\n The final step is <a href=\"${POST.oauth2.session2}\">POST /oauth2/session2<\/a> which returns an access token\n which is included as a Bearer token in the Authorization header of \n subsequent requests as described above.  Only Synapse itself may use this service, as redirection back\n from the OAuth2 provider is only allowed to the Synapse web portal.\n <\/p>\n <p>\n A registered OAuth 2.0 client can use the <a href=\"#org.sagebionetworks.auth.controller.OpenIDConnectController\">OAuth 2.0 services<\/a>\n to authenticate, the final step of which is a request to the token endpoint:\n <a href=\"${POST.oauth2.token}\">POST /oauth2/token<\/a>\n The returned access token is included as a Bearer token in the Authorization header of \n subsequent requests as described above.\n <\/p>\n <p>\n A user may freely generate up to 100 Personal access tokens (PATs) with scoped access using \n <a href=\"${POST.personalAccessToken}\">POST /personalAccessToken<\/a>. Unlike OAuth access tokens,\n <ul>\n     <li>PATs can be freely generated by a user alone and are not linked to any third party OAuth client and<\/li>\n     <li>While ATs have a strict 24 hour lifetime, PATs are long lived, and will only expire if unused for 180 consecutive days<\/li>\n <\/ul>\n For these reasons, it is critical to treat PATs as sensitive credentials, like passwords. If a user creates more than 100 tokens, then\n the least-recently used token(s) will be deleted until the user has no more than 100 tokens.\n <\/p>\n <p>\n The returned personal access token is included as a Bearer token in the Authorization header of \n subsequent requests as described above.\n <\/p>"
          },
          {
               "name": "Authentication Services (2FA)",
               "description": "<p>\n APIs to manage two factor authentication (2FA) in Synapse.\n <\/p\n <p>\n Synapse currently supports using authenticator applications that can generate a <a href=\"https://en.wikipedia.org/wiki/Time-based_one-time_password\">TOTP<\/a> that is used as a second factor. \n <\/p>\n <p>\n To enable 2FA two requests are involved:\n \n <ol>\n <li><a href=\"${POST.2fa.enroll}\">POST /2fa/enroll<\/a>: Generates a shared secret that is added to the user authenticator application<\/li>\n <li><a href=\"${POST.2fa}\">POST /2fa<\/a>: Enables a specific secret generated by 1. to be used as second factor<\/li>\n <\/ol>\n <\/p>\n \n <p>\n In order to login through 2FA an additional request needs to be performed after the user attempts to authenticate (e.g. through the <a href=\"${POST.login2}\">POST /login2<\/a> API). \n If the user has 2FA enabled, they will receive a 401 and the body of the response will contain a twoFaToken that can be used in the <a href=\"${POST.2fa.token}\">POST /2fa/token<\/a> API to obtain an access token.\n <\/p>\n \n <p>\n The user can additionally generate a set of recovery codes using the <a href=\"${POST.2fa.recoveryCodes}\">POST /2fa/recoveryCodes<\/a> API. The codes are one time use and can be used in place of a TOTP code when\n performing 2FA authentication. The body of the <a href=\"${POST.2fa.token}\">POST /2fa/token<\/a> request should specify as otpType RECOVERY_CODE and the value of the otpCode should match one of the generated codes.\n <\/p>"
          },
          {
               "name": "Certified User Services",
               "description": "To become a Synapse Certified User you must pass a test.  The Synapse APIs include\n a service to provide the test and a service to submit a test result.  There are also\n administrative services to retrieve the history of test submissions."
          },
          {
               "name": "Challenge Services",
               "description": "A Challenge is a special object that supplements a project, providing additional features\n specific to challenges.  This set of services provides \"CRUD\" for Challenge objects and\n ChallengeTeam objects, which register a Team for a Challenge.  The services also provide\n a number of queries regarding Challenges, challenge participants and challenge Teams."
          },
          {
               "name": "Curation Task Services",
               "description": "The Curation Task services are used to manage <a href=\"${org.sagebionetworks.repo.model.curation.CurationTask}\">Curation Tasks<\/a>.\n Curation tasks are used to guide data contributors through the process of contributing data or metadata in Synapse."
          },
          {
               "name": "DOI Services",
               "description": "Provides REST APIs for managing Synapse DOIs."
          },
          {
               "name": "Data Access Services",
               "description": "<p>Some data in Synapse are governed by an ACTAccessRequirement. To gain access\n to these data, a user must meet all requirements specified in the ACTAccessRequirement.<\/p>\n <br>\n <p>These services provide the APIs for users to create request to gain access to \n controlled data, and APIs for the ACT to review and grant access to users.<\/p>"
          },
          {
               "name": "Discussion Services",
               "description": "<p>Discussions in Synapse are captured in the Project's Forum. Each \n Project has a Forum. Each Forum has a set of Moderators. The Moderators manage \n the content of the Forum.<\/p>\n <br>\n <p>A Forum has multiple Threads. A Thread is created by an authorized user. \n Other authorized users can view and reply to an existing Thread.<\/p>\n <br>\n <p>These services provide the APIs for Moderators and authorized users to \n create, edit, and manage the conversations that happen in Synapse.<\/p>\n <br>"
          },
          {
               "name": "Docker Authorization Services",
               "description": "These services allow Synapse to act as an authorization service for a Docker Registry.\n For more details see: https://github.com/docker/distribution/blob/master/docs/spec/auth/token.md\n \n Authorization is either:\n <ul>\n <li>User name and password, included in the request as a Basic Authorization header<\/li>\n <li>An oauth access token, passed as a Bearer Authorization header.  To execute 'docker pull' the access token must include 'download'\n scope; to execute 'docker push' the access token must include 'modify' scope and should include 'download' scope.<\/li>\n <\/ul>"
          },
          {
               "name": "Docker Commit Services",
               "description": "These services relate to the 'commits' to Docker repositories.\n Note that create, update and delete of the Docker repositories themselves are done using\n the <a href=\"#org.sagebionetworks.repo.web.controller.EntityController\">Entity Services<\/a>,\n for external/unmanaged repositories, or by direct integration with the Docker registry, for managed\n Docker repositories.  Tagged commits for both managed and external/unmanaged repositories may be\n retrieved using the 'listDockerTags' API included in this service."
          },
          {
               "name": "Docker Registry Event Services",
               "description": "These services process events from the Docker Registry.\n They are separated from other Docker Controllers because the authorization \n is different, i.e. basic authorization using a key/value pair.\n \n These services are not intended to be used by Synapse clients, only by\n the Docker registry."
          },
          {
               "name": "Download List Services",
               "description": "Services for managing a user's download list.\n <\/p>\n Files can be added to the user's download list using\n <a href=\"${POST.download.list.add}\">POST /download/list/add<\/a>. Files can be\n removed from the user's download by calling either\n <a href=\"${POST.download.list.remove}\">POST /download/list/remove<\/a>, or the\n entire list can be cleared with: <a href=\"${DELETE.download.list}\">DELETE\n /download/list<\/a>.\n <\/p>\n In order to query the files on a user's download list, first start an\n asynchronous job using <a href=\"${POST.download.list.query.async.start}\">POST\n /download/list/query/async/start<\/a> to get an asynchToken. The job results\n can be monitored using\n <a href=\"${GET.download.list.query.async.get.asyncToken}\">GET\n /download/list/query/async/get/{asyncToken}<\/a>. While the job is still\n processing the GET call will return a status code of 202 (ACCEPTED). Once the\n job is complete the GET call will return a status code of 200 with the\n response body.\n <\/p>\n <b>Download List Service Limits<\/b>\n <table border=\"1\">\n <tr>\n <th>resource<\/th>\n <th>limit<\/th>\n <th>notes<\/th>\n <\/tr>\n <tr>\n <td>Maximum number of files on a user's download list<\/td>\n <td>100,000 files<\/td>\n <td><\/td>\n <\/tr>\n <tr>\n <td>Maximum batch size for adding/removing files<\/td>\n <td>1000 files<\/td>\n <td><\/td>\n <\/tr>\n <\/table>"
          },
          {
               "name": "Drs Services",
               "description": "<p>\n The <a href=\"https://ga4gh.github.io/data-repository-service-schemas/preview/release/drs-1.2.0/docs/\">\n Data Repository Service<\/a> API provides access to data objects in single, standard way regardless of\n where they are stored and how they are managed. The data objects for which information can be fetched are \n <a href=\"${org.sagebionetworks.repo.model.FileEntity}\">FileEntity<\/a> and\n <a href=\"${org.sagebionetworks.repo.model.table.Dataset}\">Dataset<\/a>.The data object that is downloaded is a file.\n <\/p>\n <p>\n The supported end points for DRS are:\n     <ul>\n         <li><a href=\"${GET.service-info}\"> GET /service-info<\/a><\/li>\n         <li><a href=\"${GET.objects.object_id}\"> GET /objects/{object_id}<\/a><\/li>\n     <\/ul>\n <\/p>\n <p>\n     Use the <a href=\"${GET.service-info}\"> GET /service-info <\/a> API to get information about GA4GH-compliant web services,\n     including DRS services, to be aggregated into registries and made available via a standard API.\n     <\/p>\n     Use the <a href=\"${GET.objects.object_id}\"> GET /objects/{object_id} <\/a> API to get information about individual DRS objects.\n     <\/p>"
          },
          {
               "name": "Entity Bundle Services V2",
               "description": "<p>\n The Entity Bundle Services provide bundled access to Entities and their related data components.\n An EntityBundle can be used to create, fetch, or update an Entity and associated objects with a\n single web service request.\n <\/p>"
          },
          {
               "name": "Entity Services",
               "description": "<p>\n All data in Synapse is organize into\n <a href=\"${org.sagebionetworks.repo.model.Project}\">Projects<\/a>. These\n Projects can be further organized into hierarchical\n <a href=\"${org.sagebionetworks.repo.model.Folder}\">Folders<\/a>. Finally, the\n data is then represented by\n <a href=\"${org.sagebionetworks.repo.model.FileEntity}\">FileEntities<\/a> that\n reside within Folders or directly within Projects. All these objects\n (Projects, Folders, FileEntities) are derived from a common object called\n <a href=\"${org.sagebionetworks.repo.model.Entity}\">Entity<\/a>. The Entity\n Services provide the means to create, read, update, and delete Synapse\n Entities. There are also services for navigating the Entity hierarchies ,\n setting Authorization rules, and Annotating Entities.\n <\/p>\n <p>\n In addition to the basic entity types (Project, Folder, & FileEntity),\n Synapse also supports the following Entity types:\n <ul>\n <li><a href=\"${org.sagebionetworks.repo.model.table.TableEntity}\">TableEntity<\/a><\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.docker.DockerRepository}\">DockerRepository<\/a><\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.table.EntityView}\">EntityView<\/a><\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.table.SubmissionView}\">SubmissionView<\/a><\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.table.Dataset}\">Dataset<\/a><\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.table.DatasetCollection}\">DatasetCollection<\/a><\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.table.MaterializedView}\">MaterializedView<\/a><\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.table.VirtualTable}\">VirtualTable<\/a><\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.RecordSet}\">RecordSet<\/a><\/li>\n <\/ul>\n <\/p>\n <p>\n The following methods provide the basic Create, Read, Update, Delete (CRUD)\n for Entities:\n <\/p>\n <ul>\n <li><a href=\"${POST.entity}\">POST /entity<\/a><\/li>\n <li><a href=\"${GET.entity.id}\">GET /entity/{id}<\/a><\/li>\n <li><a href=\"${PUT.entity.id}\">PUT /entity/{id}<\/a><\/li>\n <li><a href=\"${DELETE.entity.id}\">DELETE /entity/{id}<\/a><\/li>\n <\/ul>\n <h6>Annotations<\/h6>\n <p>\n An Entity can be annotated using the\n <a href=\"${PUT.entity.id.annotations2}\">PUT /entity/{id}/annotations2<\/a>\n method. Each annotation is a key-value pair. The\n <a href=\"${GET.entity.id.annotations2}\">GET /entity/{id}/annotations2<\/a>\n method can be used to get the current annotations of an entity.\n <\/p>\n <h6>Authorization<\/h6>\n <p>\n An Entity's authorization is controlled by the Entity's\n <a href=\"${org.sagebionetworks.repo.model.AccessControlList}\">Access Control\n List (ACL)<\/a>. When a new Project is created a new ACL is automatically\n created for the Project. New Folders and FileEnties start off inheriting the\n ACL of their containing Project. This means they do not have their own ACL\n and all authorization is controlled by their Project's ACL. The term\n 'benefactor' is used to indicate which Entity an Entity inherits its ACL\n from. For example, a newly created Project will be its own benefactor, while\n a new FileEntity's benefactor will start off as its containing Project. The\n current benefactor of any Entity can be determined using the\n <a href=\"${GET.entity.id.benefactor}\">GET /entity/{id}/benefactor<\/a> method.\n <\/p>\n <p>\n For the case where a Folder or FileEntity needs its own ACL (as opposed to\n inheriting it from its containing Project) a new ACL can be created for the\n Entity using the <a href=\"${POST.entity.id.acl}\">POST /entity/{id}/acl<\/a>\n method. When a new ACL is created for an Entity it will no longer inherit its\n permission from its containing Project and it will become its own benefactor.\n <\/p>\n <p>\n While creating or updating an ACL, only Certified Users can add DOWNLOAD\n permission for Authenticated Users group.\n <\/p>\n <p>\n For the case where a Folder or FileEntity no longer needs its own ACL, the\n ACL can deleted using the <a href=\"${DELETE.entity.id.acl}\">DELETE\n /entity/{id}/acl<\/a> method. When the ACL of an File or Folder is deleted, it\n will automatically be assigned the same benefactor as its parent Entity.\n Deleting the ACL of a Project is not allowed.\n <\/p>\n <p>\n The <a href=\"${GET.entity.id.acl}\">GET /entity/{id}/acl<\/a> can be used to\n get an Entity's ACL.\n <\/p>\n <p>\n To determine what permissions a User has on an Entity, the\n <a href=\"${GET.entity.id.permissions}\">GET /entity/{id}/permissions<\/a>\n method should be used.\n <\/p>\n <p>\n In addition to authorization via ACLs, entities may be restricted via\n AccessRequirements (ARs). For more information, see <a href=\"#org.sagebionetworks.repo.web.controller.AccessRequirementController\">\n Access Requirement Services<\/a> and\n <a href=\"#org.sagebionetworks.repo.web.controller.AccessApprovalController\">\n Access Approval Services<\/a>\n <\/p>\n <h6>Versions<\/h6>\n <p>\n Currently,\n <a href=\"${org.sagebionetworks.repo.model.FileEntity}\">FileEntities<\/a> are\n \"versionable\" meaning it is possible for it to have multiple versions of the\n file. Whenever, a FileEntity is updated with a new\n <a href=\"${org.sagebionetworks.repo.model.file.FileHandle}\">FileHandle<\/a>\n whose MD5 differs from the MD5 of the current file hanlde a new version of\n the FileEntity is automatically created. The history of a FileEntity can be\n retrieved using <a href=\"${GET.entity.id.version}\">GET\n /entity/{id}/version<\/a> method. A specific version of a FileEntity can be\n retrieved using <a href=\"${GET.entity.id.version.versionNumber}\">GET\n /entity/{id}/version/{versionNumber}<\/a> method. The Annotations of a\n specific version of an FileEntity can be retrieved using the\n <a href=\"${GET.entity.id.version.versionNumber.annotations2}\">GET\n /entity/{id}/version/{versionNumber}/annotations<\/a> method.\n <\/p>\n <p>\n Despite being <a href=\"${org.sagebionetworks.repo.model.VersionableEntity}\">versionable<\/a>,\n <a href=\"${org.sagebionetworks.repo.model.table.TableEntity}\">Tables<\/a>,\n <a href=\"${org.sagebionetworks.repo.model.table.View}\">Views<\/a> and <a href=\"${org.sagebionetworks.repo.model.table.MaterializedView}\">Materialized\n Views<\/a> are versioned using snapshots: see\n <a href=\"${POST.entity.id.table.snapshot}\">POST\n /entity/{id}/table/snapshot<\/a> and\n <a href=\"${POST.entity.id.table.transaction.async.start}\">POST\n /entity/{id}/table/transaction/async/start<\/a>.\n <\/p>\n <p>\n <b><i>Note: <\/b>Only the File and Annotations of an Entity are included in\n the version. All other components of an Entity such as description, name,\n parent, ACL, and WikiPage are <b>not<\/b> not part of the version, and will\n not vary from version to version.<\/i>\n <\/p>\n <h6>JSON Schemas<\/h6>\n <p>\n Each Entity type and Model object in Synapse is defined by a JSON schema. The\n <a href=\"${GET.REST.resources}\">GET /REST/resources<\/a> method will list the\n full name of all Resources used by Synapse. The schema for each Resource is\n accessible via <a href=\"${GET.REST.resources.schema}\">GET\n /REST/resources/schema<\/a>. Note: Many of these resources are composition\n objects and one must navigate various interfaces of an object to fully digest\n it. Therefore, a flattened (or effective) schema for each resource is\n available from the <a href=\"${GET.REST.resources.effectiveSchema}\">GET\n /REST/resources/effectiveSchema<\/a>\n <\/p>\n <b>Entity Service Limits<\/b>\n <table border=\"1\">\n <tr>\n <th>resource<\/th>\n <th>limit<\/th>\n <\/tr>\n <tr>\n <td>Maximum size of an Entity.name<\/td>\n <td>256 characters<\/td>\n <\/tr>\n <tr>\n <td>Maximum size of an Entity.desciption<\/td>\n <td>1000 characters<\/td>\n <\/tr>\n <\/tr>\n <tr>\n <td>Maximum number of versions for a single Entity<\/td>\n <td>15,000<\/td>\n <\/tr>\n <tr>\n <td>Maximum number of keys in Annotations<\/td>\n <td>100<\/td>\n <\/tr>\n <tr>\n <td>Maximum number of values associated with a single key in Annotations<\/td>\n <td>100<\/td>\n <\/tr>\n <tr>\n <td>Maximum total character count for all values associated with a single key\n in Annotations when the AnnotationValueType is STRING<\/td>\n <td>500<\/td>\n <\/tr>\n <tr>\n <td>Maximum hierarchical depth of an Entity<\/td>\n <td>50<\/td>\n <\/tr>\n <\/table>"
          },
          {
               "name": "Evaluation Services",
               "description": "<p>\n The Evaluation API is designed to support open-access data analysis and modeling challenges in\n Synapse. This framework provides tools for administrators to collect and analyze data models\n from Synapse users created for a specific goal or purpose.\n <\/p>\n  \n <p>\n The data model of the Evaluation API is built around around two primary objects:\n <ul>\n <li> <a href=\"${org.sagebionetworks.evaluation.model.Evaluation}\">Evaluation<\/a>: The primary\n object representing a Synapse Evaluation. Access to Evaluations is governed by an <a href=\"${org.sagebionetworks.repo.model.AccessControlList}\">Access Control\n List (ACL)<\/a>.\n <\/li> \n <li> <a href=\"${org.sagebionetworks.evaluation.model.Submission}\">Submission<\/a>: A user\n in a Synapse Evaluation can submit a Synapse Entity as Submission to that Evaluation. Submission\n data is owned by the parent Evaluation, and is immutable.\n <\/ul>\n <\/p>\n \n <p>\n The data model includes additional objects to support scoring of Submissions and convenient data \n access:\n <ul>\n <li> <a href=\"${org.sagebionetworks.evaluation.model.SubmissionStatus}\">SubmissionStatus<\/a>: An\n object used to track scoring information for a single Submission. This object is intended to be\n modified by the users (or test harnesses) managing the Evaluation.\n <\/li> \n <li> <a href=\"${org.sagebionetworks.evaluation.model.SubmissionBundle}\">SubmissionBundle<\/a>: \n A convenience object to transport a Submission and its accompanying SubmissionStatus in a single\n web service call.\n <\/li>\n <li> <a href=\"${org.sagebionetworks.repo.model.table.SubmissionView}\">SubmissionView<\/a>: \n A submission view can be created using the \n <a href=\"${org.sagebionetworks.repo.web.controller.EntityController}\">Entity Services<\/a> providing\n as scope a list of evaluation ids, in order to query the set of submissions through \n the <a href=\"${POST.entity.id.table.query.async.start}\">Table Query Services<\/a>.\n <a href=\"${org.sagebionetworks.repo.model.annotation.v2.Annotations}\">Annotations<\/a> set in \n the submissionAnnotations property of a <a href=\"${org.sagebionetworks.evaluation.model.SubmissionStatus}\">SubmissionStatus<\/a> \n can be exposed in the view.\n <\/li>\n <\/ul>\n <\/p>\n \n The Evaluation API supports data access mechanisms to monitor Evaluation activity for on-demand \n scoring and leaderboarding."
          },
          {
               "name": "File Services",
               "description": "<p>\n A FileHandle is an abstraction for a reference to a file in Synapse.  For details on the various types see: <a href=\"${org.sagebionetworks.repo.model.file.FileHandle}\">FileHandle<\/a>.\n <\/p>\n <p>\n <b>Multi-part File Upload API<\/b>\n <\/p>\n <p>\n In order to ensure file upload is robust, all files must be uploaded to\n Synapse in 'parts'. This means clients are expected to divide each file into\n 'parts' and upload each part separately. Since Synapse tracks the state of\n all multi-part uploads, upload failure can be recovered simply by uploading\n all parts that Synapse reports as missing.\n <\/p>\n <p>\n <i>Note: For multi-part upload 1 MB is defined as 1024*1024 bytes <\/i>\n <\/p>\n <p>\n The first task in multi-part upload is choosing a part size. The minimum part\n size is 5 MB (1024*1024*5) and the maximum part size is 5 GB (1024*1024*1024*5). \n Therefore, any file with a size less than or equal to 5 MB will have a single part and a partSize=5242880. \n The maximum number of parts for a single file 10,000 parts. The following should be used\n to choose a part size:\n <\/p>\n <p>\n partSize = max(5242880, (fileSize/10000))\n <\/p>\n <p>\n Once a partSize is chosen, a multi-part upload can be started using the\n following: <a href=\"${POST.file.multipart}\">POST /file/multipart<\/a> which\n will return an <a href=\"${org.sagebionetworks.repo.model.file.MultipartUploadStatus}\">MultipartUploadStatus<\/a>. The client is expected to use\n MultipartUploadStatus to drive the upload. The client will need to upload\n each missing part (parts with '0' in the partsState) as follows:\n <\/p>\n <p>\n <ol>\n <li>Get a pre-signed URL to upload the part to using: <a href=\"${POST.file.multipart.uploadId.presigned.url.batch}\">POST\n /file/multipart/{uploadId}/presigned/url/batch<\/a><\/li>\n <li>Upload the part to the pre-signed URL using HTTPs PUT<\/li>\n <li>Add the part to the multi-part upload using: <a href=\"${PUT.file.multipart.uploadId.add.partNumber}\">PUT\n /file/multipart/{uploadId}/add/{partNumber}<\/a><\/li>\n <\/ol>\n <\/p>\n <p>\n Once all parts have been successfully added to the multi-part upload, the\n upload can be completed using: <a href=\"${PUT.file.multipart.uploadId.complete}\">PUT\n /file/multipart/{uploadId}/complete<\/a> to produce a new <a href=\"${org.sagebionetworks.repo.model.file.FileHandle}\">FileHandle<\/a> If\n the upload fails for any reason, the client should start over ( <a href=\"${POST.file.multipart}\">POST /file/multipart<\/a>) and continue by\n uploading any parts that are reported as missing.\n <\/p>\n <p>\n <b>Multi-part File Copy API<\/b>\n <\/p>\n <p>\n The multipart API supports a robust copy of existing files to other locations (e.g. in case of a data migration)\n without the need to download and re-upload the file. This is currently supported only from and to S3 storage locations that reside in the same region.\n In order to initiate a multipart copy, a <a href=\"${POST.file.multipart}\">POST /file/multipart<\/a> request can be sent\n using as the body of the request a <a href=\"${org.sagebionetworks.repo.model.file.MultipartUploadCopyRequest}\">MultipartUploadCopyRequest<\/a>.\n <\/p>\n <p>\n The part size allows to parallelize the copy in multiple sub-parts, the same limits of the upload applies to the copy (e.g. it is possible to copy \n a file in a single part up to 5 GB). When initiating a copy we recommend to choose the part size as follows:\n <\/p>\n <p>\n partSize = max(104857600, (fileSize/10000))\n <\/p>\n <p>\n Once the multipart copy is initiated the process is the same as the multipart upload:\n <\/p>\n <p>\n <ol>\n <li>\n Get the part copy pre-signed URLs using: <a href=\"${POST.file.multipart.uploadId.presigned.url.batch}\">POST\n /file/multipart/{uploadId}/presigned/url/batch<\/a>\n <\/li>\n <li>\n For each pre-signed URL perform an HTTP PUT request with no body, the response of the previous endpoint contains a map of headers that are \n signed with the URL, all of the headers MUST be included in the PUT request.\n <\/li>\n <li>Once the copy request is performed, add the part to the multi-part copy using: <a href=\"${PUT.file.multipart.uploadId.add.partNumber}\">PUT\n /file/multipart/{uploadId}/add/{partNumber}<\/a>. \n The value of the partMD5Hex parameter will be MD5 checksum returned in the response of the request sent to the pre-signed URL.\n <\/li>\n <li>\n Once all parts have been successfully added to the multi-part copy, the\n copy can be completed using: <a href=\"${PUT.file.multipart.uploadId.complete}\">PUT\n /file/multipart/{uploadId}/complete<\/a> to produce a new <a href=\"${org.sagebionetworks.repo.model.file.FileHandle}\">FileHandle<\/a>\n <\/li>\n <\/ol>\n <\/p>\n <p>\n Note about the copy integrity: The resulting file handle will have the same content MD5 of the source file handle, but synapse\n does not try to re-compute or verify this value. Instead, the integrity check is performed by the cloud provider (currently only S3)\n during the copy request for the part (the request sent to the pre-signed URL). Each copy pre-signed URL is signed with a special\n header that makes sure that the source file didn't change during the copy, if this is the case the PUT request to the pre-signed URL\n will fail and a new copy should be re-started.\n <\/p>\n <p>\n <b>Associating FileHandles with Synapse objects<\/b>\n <\/p>\n <p>\n FileHandles can be associated with various type of objects such as a <a href=\"${org.sagebionetworks.repo.model.FileEntity}\">FileEntity<\/a> and  <a href=\"${org.sagebionetworks.repo.model.wiki.WikiPage}\">WikiPage<\/a>. The full list of association types can be found in the <a href=\"${org.sagebionetworks.repo.model.file.FileHandleAssociateType}\">FileHandleAssociateType<\/a> enumeration.\n <p>\n Note that a file handle MUST always be associated with an object, if a file handle is not associated with an objects for more than 30 days Synapse will mark it as <a href=\"${org.sagebionetworks.repo.model.file.FileHandleStatus}\">UNLINKED<\/a> and eventually archive or delete it from the system.\n <\/p>\n <p>\n For more information see the following:\n <\/p>\n <ul>\n <li><a href=\"${org.sagebionetworks.repo.model.FileEntity}\">FileEntity<\/a>\n <li><a href=\"${POST.entity}\">POST /entity<\/a>\n <li><a href=\"${PUT.entity.id}\">PUT /entity/{id}<\/a>\n <li><a href=\"${GET.entity.id.filepreview}\">GET /entity/{id}/filepreview<\/a>\n <li><a href=\"${GET.entity.id.version.versionNumber.filepreview}\">GET\n /entity/{id}/version/{versionNumber}/filepreview<\/a>\n <li><a href=\"${GET.entity.id.filehandles}\">GET /entity/{id}/filehandles<\/a>\n <li><a href=\"${GET.entity.id.version.versionNumber.filehandles}\">GET\n /entity/{id}/version/{versionNumber}/filehandles<\/a>\n <li><a href=\"${POST.fileHandle.batch}\">POST /fileHandle/batch<\/a>\n <\/ul>\n <b>Service Limits<\/b>\n <table border=\"1\">\n <tr>\n <th>resource<\/th>\n <th>limit<\/th>\n <th>notes<\/th>\n <\/tr>\n <tr>\n <td>Minimum file size<\/td>\n <td>0 bytes<\/td>\n <td><\/td>\n <\/tr>\n <tr>\n <td>Maximum file size<\/td>\n <td>5 TB (5,497,558,100,000 bytes)<\/td>\n <td><\/td>\n <\/tr>\n <tr>\n <tr>\n <td>Maximum number of parts<\/td>\n <td>10,000<\/td>\n <td><\/td>\n <\/tr>\n <td>Minimum file part size<\/td>\n <td>5 MB (5,242,880 bytes)<\/td>\n <td>The recommended part size for an upload is max(5242880, (fileSize/10000)). For a copy max(104857600, (fileSize/10000)).<\/td>\n <\/tr>\n <tr>\n <td>Maximum file part size<\/td>\n <td>5 GB (5,368,709,120 bytes)<\/td>\n <td><\/td>\n <\/tr>\n <\/table>"
          },
          {
               "name": "Form Services",
               "description": "Collection of APIs from managing and submitting form data. There are two\n basic objects:\n <ul>\n <li><a href=\"${org.sagebionetworks.repo.model.form.FormData}\">FormData<\/a> -\n Represent an end user's data gathered from a form template. All FormData\n belongs to a single FormGroup.<\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.form.FormGroup}\">FormGroup<\/a>\n - Represents a grouping of FormData with an\n <a href=\"${org.sagebionetworks.repo.model.AccessControlList}\">Access Control\n List (ACL)<\/a> for administration. The ACL controls both who can submit data\n to the group and who has access to the submitted data.<\/li>\n <\/ul>\n <p>\n To download the data associated with a FormData object use:\n <a href=\"${POST.fileHandle.batch}\">POST /fileHandle/batch<\/a> providing the\n formData.dataFileHandleId with <a href=\"${org.sagebionetworks.repo.model.file.FileHandleAssociateType}\">FileHandleAssociateType.FormData<\/a>"
          },
          {
               "name": "Grid Services",
               "description": "Services for create and managing grid data session."
          },
          {
               "name": "JSON Schema Services",
               "description": "This set of services provide project designers with tools to define their own\n schemas to control and validate metadata applied to Projects, Folders, and\n Files. All schemas are defined using JSON schemas following\n <a href=\"https://json-schema.org/\">json-schema.org<\/a> specification.\n <p>\n To get started, you will need to either create a new <a href=\"${org.sagebionetworks.repo.model.schema.Organization}\">Organization<\/a> or\n join an existing Organization. Each Organization has an AccessControlList\n (ACL) that controls which users/teams are authorized to contribute schemas\n under that Organization's name-space. The Organization's name-space is\n referenced using the Organization's name, which is also the root of all\n schema $ids within the Organization.\n <\/p>\n \n \n <p>\n <b>Binding JSON schemas to Entities:<\/b>\n <ul>\n <li><a href=\"${PUT.entity.id.schema.binding}\">PUT /entity/{id}/schema/binding<\/a><\/li>\n <li><a href=\"${GET.entity.id.schema.binding}\">GET /entity/{id}/schema/binding<\/a><\/li>\n <li><a href=\"${DELETE.entity.id.schema.binding}\">DELETE /entity/{id}/schema/binding<\/a><\/li>\n <\/ul>\n <\/p>\n <p>\n <b>Entity schema validation results:<\/b>\n <ul>\n <li><a href=\"${GET.entity.id.schema.validation}\">GET /entity/{id}/schema/validation<\/a><\/li>\n <li><a href=\"${GET.entity.id.schema.validation.statistics}\">GET /entity/{id}/schema/validation/statistics<\/a><\/li>\n <li><a href=\"${POST.entity.id.schema.validation.invalid}\">POST /entity/{id}/schema/validation/invalid<\/a><\/li>\n <li><a href=\"${GET.entity.id.derivedKeys}\">GET /entity/{id}/derivedKeys<\/a><\/li>\n <\/ul>\n <\/p>  \n \n <b>Service Limits<\/b>\n <table border=\"1\">\n <tr>\n <th>resource<\/th>\n <th>limit<\/th>\n <\/tr>\n <tr>\n <td>Maximum number of characters in a JSON schema<\/td>\n <td>2^24 characters<\/td>\n <\/tr>\n <\/table>"
          },
          {
               "name": "Log Service",
               "description": "https://sagebionetworks.jira.com/wiki/display/PLFM/Repository+Service+API#RepositoryServiceAPI-QueryAPI"
          },
          {
               "name": "Membership Invitation Services",
               "description": "The Membership Invitation Services create, retrieve and delete \n membership invitations.  A membership invitation is created by a Team administrator\n to invite a Synapse user to join the Team.  Without the invitation it is not possible\n for an outside user to join.  For more on Teams, see\n <a href=\"#org.sagebionetworks.repo.web.controller.TeamController\">Team Services<\/a>."
          },
          {
               "name": "Membership Request Services",
               "description": "The Membership Request Services create, retrieve and delete \n membership requests.  A membership request is created by a Synapse user\n to request admission to a Team.  Without the request it is not possible\n for a Team to admit the user.  For more on Teams, see\n <a href=\"#org.sagebionetworks.repo.web.controller.TeamController\">Team Services<\/a>."
          },
          {
               "name": "Message Services",
               "description": "<p>\n Provides REST APIs for sending messages to other Synapse users and for commenting on Synapse entities.\n <\/p>"
          },
          {
               "name": "OpenID Connect Services",
               "description": "The OpenID Connect (OIDC) services implement OAuth 2.0 with the OpenID identity extensions."
          },
          {
               "name": "Portals Services",
               "description": "Provides APIs to manage Synapse portals, generally managed by Synapse administrators."
          },
          {
               "name": "Principal Services",
               "description": "A <a href=\"http://en.wikipedia.org/wiki/Principal_%28computer_security%29\">\n Principal<\/a> in Synapse can be a User, Group, or a Team. This is a set of\n services that provides the means to look-up principals by their various\n attributes and also to test unique names such as USER_NAME, USER_EMAIL, or\n TEAM_NAME are available for use."
          },
          {
               "name": "Project Settings Services",
               "description": "The project settings services provide configuration options that can be applied to projects. In particular through the <a href=\"${POST.projectSettings}\">POST /projectSettings<\/a> and <a href=\"${PUT.projectSettings}\">PUT /projectSettings<\/a> services\n a user can create or update the setting of a specific <a href=\"${org.sagebionetworks.repo.model.project.ProjectSettingsType}\">type<\/a> for a project.\n <\/p>\n Currently supported settings for a project are:\n \n <ul>\n <li><a href=\"${org.sagebionetworks.repo.model.project.UploadDestinationListSetting}\">UploadDestinationListSetting<\/a>: Used to customize the storage location for files in a project<\/li>\n <\/ul>\n\n <\/p>\n The <a href=\"${POST.storageLocation}\">POST /storageLocation<\/a> service is provided in order to create <a href=\"${org.sagebionetworks.repo.model.project.StorageLocationSetting}\">StorageLocationSetting<\/a>. The id of a\n <a href=\"${org.sagebionetworks.repo.model.project.StorageLocationSetting}\">StorageLocationSetting<\/a> can then be set in the <b>locations<\/b> property of \n the <a href=\"${org.sagebionetworks.repo.model.project.UploadDestinationListSetting}\">UploadDestinationListSetting<\/a>.\n <\/p>\n When uploading a file the id of the default <a href=\"${org.sagebionetworks.repo.model.project.StorageLocationSetting}\">StorageLocationSetting<\/a> to be used on a folder can be retrieved\n using the <a href=\"${GET.entity.id.uploadDestination}\">GET /entity/{id}/uploadDestination<\/a> service using the id of the parent entity (e.g. a folder or a project).\n <\/p>\n By setting a custom storage location, users can store the data in their own S3 or Google Cloud bucket. Note that when a folder or a project is configured to use a custom storage location,\n only future uploads through Synapse are affected (e.g. changing the storage location does not automatically change the location of existing files).\n For a guide on setting a custom storage location, see the <a href=\"https://help.synapse.org/docs/Custom-Storage-Locations.2048327803.html\">Custom Storage Location<\/a> documentation\n article.\n <\/p>"
          },
          {
               "name": "Project Storage Services",
               "description": "Services to manage project storage usage and limits."
          },
          {
               "name": "Realm Services",
               "description": "Auto-generated description"
          },
          {
               "name": "Recycle Bin Services",
               "description": "The recycle bin (or trash can) is the special folder that holds the deleted entities for users.\n <p>\n Services are provided for users to delete entities into the trash can, to view entities\n in the trash can, to purge entities from the trash can, and to restore entities out\n of the trash can."
          },
          {
               "name": "Search Services",
               "description": "Search for Entities on Synapse"
          },
          {
               "name": "Statistics Services",
               "description": "Services that expose statistics computed by the backend."
          },
          {
               "name": "Storage Report Services",
               "description": "Provides REST APIs for generating Storage Reports. These may only be used by the Synapse Report Team."
          },
          {
               "name": "Subscription Services",
               "description": "<p>While working in Synapse, users may want to subscribe to different topics\n to receive notifications about changes in those topics.<\/p>\n <br>\n <p>These services provide the APIs for Synapse users to manage their subscriptions.<\/p>\n <br>"
          },
          {
               "name": "Table Services",
               "description": "<p>\n A Synapse\n <a href=\"${org.sagebionetworks.repo.model.table.TableEntity}\">TableEntity<\/a>\n model object represents the metadata of a table. Each TableEntity is defined\n by a list of\n <a href=\"${org.sagebionetworks.repo.model.table.ColumnModel}\">ColumnModel<\/a>\n IDs. Use <a href=\"${POST.column}\">POST /column<\/a> to create new ColumnModel\n objects. Each ColumnModel object is immutable, so to change a column of a\n table a new column must be added and the old column must be removed.\n TableEntities can be created, updated, read and deleted like any other\n entity:\n <ul>\n <li><a href=\"${POST.entity}\">POST /entity<\/a><\/li>\n <li><a href=\"${GET.entity.id}\">GET /entity/{id}<\/a><\/li>\n <li><a href=\"${PUT.entity.id}\">PUT /entity/{id}<\/a><\/li>\n <li><a href=\"${DELETE.entity.id}\">DELETE /entity/{id}<\/a><\/li>\n <\/ul>\n <\/p>\n <p>\n <p>\n All ColumnModel objects are publicly viewable and usable. Since each\n ColumnModel is immutable it is safe to re-use ColumnModels created by other\n users. Use the <a href=\"${GET.column}\">GET /column<\/a> services to list all\n of the existing ColumnModels that are currently in use.\n <\/p>\n \n Once the columns for a TableEntity have been created and assigned to the\n TableEntity, rows can be added to the table using\n <a href=\"${POST.entity.id.table.transaction.async.start}\">POST\n /entity/{id}/table/transaction/async/start<\/a>. Each\n <a href=\"${org.sagebionetworks.repo.model.table.Row}\">Row<\/a> appended to the\n table will automatically be assigned a rowId and a versionNumber and can be\n found in the resulting\n <a href=\"${org.sagebionetworks.repo.model.table.RowReferenceSet}\">RowReferenceSet<\/a>. To update a row, simply include the row's rowId in the\n passed <a href=\"${org.sagebionetworks.repo.model.table.RowSet}\">RowSet<\/a>.\n Any row without a rowId will be treated as a new row. When a row is updated a\n new versionNumber will automatically be assigned the Row. While previous\n versions of any row are kept, only the current version of any row will appear\n in the table index used to support the query service:\n <a href=\"${POST.entity.id.table.query.async.start}\">POST\n /entity/{id}/table/query/async/start<\/a>\n <\/p>\n <p>\n Use the <a href=\"${POST.entity.id.table.query.async.start}\">POST\n /entity/{id}/table/query/async/start<\/a> services to query for the current\n rows of a table. The returned\n <a href=\"${org.sagebionetworks.repo.model.table.RowSet}\">RowSet<\/a> of the\n table query can be modified and returned to update the rows of a table using\n <a href=\"${POST.entity.id.table.transaction.async.start}\">POST\n /entity/{id}/table/transaction/async/start<\/a>.\n <\/p>\n <p>\n There is also an <a href=\"${org.sagebionetworks.repo.web.controller.AsynchronousJobController}\">asynchronous service<\/a> to\n <a href=\"${org.sagebionetworks.repo.model.table.UploadToTableRequest}\">upload<\/a> and\n <a href=\"${org.sagebionetworks.repo.model.table.DownloadFromTableRequest}\">download<\/a> csv files, suitable for large datasets.\n <\/p>\n <p>\n <b>Table Service Limits<\/b>\n <table border=\"1\">\n <tr>\n <th>resource<\/th>\n <th>limit<\/th>\n <th>notes<\/th>\n <\/tr>\n <tr>\n <td>Maximum size of column names<\/td>\n <td>256 characters<\/td>\n <td><\/td>\n <\/tr>\n <tr>\n <td>Maximum number of enumeration values for a single column<\/td>\n <td>100<\/td>\n <td><\/td>\n <\/tr>\n <tr>\n <td>Maximum number of columns per table/view<\/td>\n <td>152<\/td>\n <td><\/td>\n <\/tr>\n <tr>\n <td>The maximum possible width of a table/view<\/td>\n <td>64 KB<\/td>\n <td>Each\n <a href=\"${org.sagebionetworks.repo.model.table.ColumnType}\">ColumnType<\/a>\n has a maximum possible size. The total width of a table/view is the sum of\n the maximum size of each of its columns<\/td>\n <\/tr>\n <tr>\n <td>The maximum number of LARG_TEXT columns per table/view<\/td>\n <td>30<\/td>\n <td><\/td>\n <\/tr>\n <td>Maximum table size<\/td>\n <td>~146 GB<\/td>\n <td>All row changes applied to a table are automatically batched into changes\n sets with a maximum size of 5242880 bytes (5 MB). Currently, there is a limit\n of 30,000 change sets per table. Therefore, the theoretical maximum size of\n table is 5242880 bytes * 30,000 = ~ 146 GB.<\/td>\n <\/tr>\n <tr>\n <td>The maximum number of projects/folder per view scope<\/td>\n <td>30 K<\/td>\n <td>Recursive sub-folders count towards this limit. For example, if a project\n contains more than 30 K sub-folders then it cannot be included in a view's\n scope.<\/td>\n <\/tr>\n <tr>\n <td>The maximum number of rows per view<\/td>\n <td>200 M<\/td>\n <td>A single folder cannot contain more then 10 K files/folders. Since a\n view's scope is limited to 30 K project/folders, the maximum number of rows\n per view is 10 K * 30 K = 300 M.<\/td>\n <\/tr>\n <tr>\n <td>The maximum file size of a CSV that can be appended to a table<\/td>\n <td>1 GB<\/td>\n <td><\/td>\n <\/tr>\n <tr>\n <td>The maximum size of a single query result<\/td>\n <td>512000 bytes<\/td>\n <td><\/td>\n <\/tr>\n <tr>\n <td>Entity View only: The maximum total character length for a STRING or STRING_LIST <a href=\"${org.sagebionetworks.repo.model.table.ColumnType}\">ColumnType<\/a><\/td>\n <td>500 characters<\/td>\n <td>Entity Views ONLY! This follows limitations placed on Annotations. For the type STRING_LIST, the total character count is the cumulative length of all string contained in the list.<\/td>\n <\/tr>\n <tr>\n <td>Entity View only: The maximum list length for \"_LIST\" suffixed <a href=\"${org.sagebionetworks.repo.model.table.ColumnType}\">ColumnType<\/a><\/td>\n <td>100 values<\/td>\n <td>Entity Views ONLY! This follows limitations placed on Annotations.<\/td>\n <\/tr>\n <\/table>"
          },
          {
               "name": "Team Services",
               "description": "Teams are groups of users.  Teams can be granted access permissions to projects, \n folders and files, and share other resources by adding them to\n <a href=\"${org.sagebionetworks.repo.model.AccessControlList}\">Access Control\n Lists (ACLs)<\/a>.  Any authenticated Synapse user\n may create a Team, for which they become an administrator.  Team\n administrators may:\n <ul>\n <li> invite other users to join the Team, \n <li> accept membership requests from users wishing to join the Team, \n <li> grant or revoke administrative control to Team members,\n <li> remove a user from the Team.  \n <\/ul>\n <br>\n Other Synapse users may:\n <ul>\n <li> issue membership requests to a Team,\n <li> accept Team membership invitations (join the Team),\n <li> unilaterally choose to leave a Team once added.\n <\/ul>"
          },
          {
               "name": "User & Group Services",
               "description": "Auto-generated description"
          },
          {
               "name": "User Profile Services",
               "description": "Every Synapse user has an associated <a href=\"${org.sagebionetworks.repo.model.UserProfile}\">UserProfile<\/a>."
          },
          {
               "name": "Verification Services",
               "description": "Identity verification is a service offered by the Synapse Access and Compliance Team\n to add an additional layer of legitimacy to a user account, beyond the basic\n requirements for creating an account in Synapse.  After completing their user\n profile a user may submit a verification request, including supporting documentation.\n The ACT reviews the information then approves or rejects it.  After approval, the\n ACT retains the authority to suspend verification of an account previously verified.\n Once rejected or suspended a user may create a new verification request."
          },
          {
               "name": "Webhook Services",
               "description": "Provides APIs to manage webhooks that are triggered by synapse events.\n <p>\n A webhook can specify the id of a synapse entity to receive events for. For entities that represent a container (folder and project), \n matching events are published to the webhook endpoint for any entity in their hierarchy.\n <p>\n Before events are published to the endpoint, the webhook needs to be verified. A special request is sent to the webhook endpoint \n containing a verification code that can be submitted in the body of the <a href=\"${POST.webhook.webhookId.verify}\">POST /webhook/{webhookId}/verify<\/a> request.\n <h6>Request Format<\/h6>\n There are two types of requests that can be sent to an endpoint:\n <ul>\n <li><a href=\"${org.sagebionetworks.repo.model.webhook.WebhookVerificationMessage}\">WebhookVerificationMessage<\/a>: Sent when a webhook is created or when its endpoint is updated that contains the verification code used to verify the webhook.<\/li>\n <li><a href=\"${org.sagebionetworks.repo.model.webhook.WebhookSynapseEventMessage}\">WebhookSynapseEventMessage<\/a>: Sent when a synapse event that match the webhook entity is generated in the backend.<\/li>\n <\/ul>\n Each HTTP request will contain the following custom headers:\n <ul>\n <li><b>X-Syn-Webhook-Id<\/b>: The id of the webhook<\/li>\n <li><b>X-Syn-Webhook-Message-Type<\/b>: The type of message body, either Verification or SynapseEvent<\/li>\n <li><b>X-Syn-Webhook-Message-Id<\/b>: A unique id for the message<\/li>\n <li><b>X-Syn-Webhook-Owner-Id<\/b>: The id of the user that created the webhook<\/li>\n <\/ul>\n And the following standard headers:\n <ul>\n <li><b>Content-Type<\/b>: Always application&#47;json<\/li>\n <li><b>User-Agent<\/b>: Set with the prefix Synapse-Webhook&#47;, followed by the synapse stack version<\/li>\n <li><b>Authorization<\/b>: Set with the Bearer prefix, followed by an authentication token (See below)<\/li>\n <\/ul>\n <h6>Request Handling<\/h6>\n A request to an endpoint is sent at least once and retried for a maximum of 3 times. The endpoint needs to provide a response within 2 seconds in order for the request to be considered successful, \n otherwise the request is retried. Valid HTTP response codes are: \n <ul>\n <li>200 (OK)<\/li> \n <li>201 (CREATED)<\/li>\n <li>202 (ACCEPTED)<\/li>\n <li>204 (NO CONTENT)<\/li> \n <\/ul>\n The following response codes are considered for retrying: \n <ul>\n <li>429 (TOO MANY REQUESTS)<\/li>\n <li>500 (INTERNAL SERVER ERROR)<\/li>\n <li>502 (BAD GATEWAY)<\/li>\n <li>503 (SERVICE UNAVAILABLE)<\/li>\n <li>504 (GATEWAY TIMEOUT)<\/li> \n <\/ul>\n Any other response code is considered a failed delivery and won't be retried. If a webhook endpoint consistently fails to respond to requests, it will eventually be disabled \n and the <a href=\"${org.sagebionetworks.repo.model.webhook.WebhookVerificationStatus}\">verification status<\/a> of the webhook will be set to REVOKED and will need to be re-verified.\n <h6>Limits<\/h6>\n Each user is limited to a maximum of 25 webhooks. The webhook endpoint is checked against a white list of allowed domain patterns, currently only the AWS Api Gateway <a href=\"https://docs.aws.amazon.com/apigateway/latest/developerguide/how-to-call-api.html\">execute-api<\/a> is allowed.\n For adding a new domain exception you can submit a request to the <a href=\"https://sagebionetworks.jira.com/servicedesk/customer/portal/9\">Synapse Service Desk<\/a>.\n <h6>Authentication<\/h6>\n By default each request includes a signed JSON Web Token (JWT) in the <b>Authorization<\/b> header as a bearer token. The token is signed with a JSON Web Key (JWK) and \n can be verified using the public JWK id specified in the header of the JWT. The public keys are published under the \"well-known\" discovery document of the issuer (See below).\n <p>\n The JWT will contain a set of <a href=\"https://www.iana.org/assignments/jwt/jwt.xhtml#claims\">standard claims<\/a> that can be used to validate the token:\n <ul>\n <li><b>iss<\/b>: The issuer of the token is set to <a href=\"https://repo-prod.prod.sagebase.org/auth/v1\">https://repo-prod.prod.sagebase.org/auth/v1<\/a>. The openid discovery document (<a href=\"https://repo-prod.prod.sagebase.org/auth/v1/.well-known/openid-configuration\">https://repo-prod.prod.sagebase.org/auth/v1/.well-known/openid-configuration<\/a>)\n can be used to get information about the JWKs<\/li>\n <li><b>aud<\/b>: The audience contains the id of the user that owns the webhook<\/li>\n <li><b>iat<\/b>: The timestamp when the token was generated<\/li>\n <li><b>exp<\/b>: The expiration time of the token, each token is valid for 30 seconds.<\/li>\n <\/ul>\n To verify the integrity of the message, the MD5 of the request body is included under the custom claim <b>message_md5<\/b> and can be verified against the md5 of the request body once the JWT is verified."
          },
          {
               "name": "WikiPage Services",
               "description": "<p>\n The Synapse <a href=\"${org.sagebionetworks.repo.model.wiki.WikiPage}\">WikiPage<\/a> model\n object contains the data needed to render an end-user crafted web page. The\n Synapse Web Client will dynamically render a WikiPage into a combination of\n HTML, CSS and Javascript which is then finally rendered as a web page in the\n client's web browser.\n <\/p>\n <p>\n These services provide support for creating, reading, updating, and\n deleting (CRUD) the WikiPage model objects.\n <\/p>\n <p>\n WikiPages are composed of two major parts; the raw markdown text and a list\n of file attachments. For example, to embed an image from an end-user's\n machine into a WikiPage, the image file must first be uploaded to Synapse as <a href=\"${org.sagebionetworks.repo.model.file.FileHandle}\">FileHandle<\/a> (see\n <a href=\"${org.sagebionetworks.file.controller.UploadController}\">File\n Services<\/a>). The FileHandle ID can then be added to a\n WikiPage.attachmentFileHandleIds list. See <a href=\"https://www.synapse.org\">www.synapse.org<\/a> for details on the\n supported markdown syntax.\n <\/p>\n \n <p>\n WikiPages are not stand-alone objects, instead they are a component of\n another object such as an Entity or Evaluation. For example, when a WikiPage\n is created for an Entity, the Entity becomes the \"owner\" of the WikiPage.\n Access to the WikiPage is always tied to its owner. For example, to GET a\n WikiPage of an Entity, the caller must have read permission on the Entity.\n <\/p>\n <p>\n To navigate the hierarchy of WikiPages associated with an owner use the <a href=\"${GET.entity.ownerId.wikiheadertree}\">GET\n /entity/{ownerId}/wikiheadertree<\/a> method. The returned list of <a href=\"${org.sagebionetworks.repo.model.wiki.WikiHeader}\">WikiHeaders<\/a> can\n be used to construct a full wiki hierarchy tree for that owner.\n <\/p>\n <p>\n Note: WikiPages can be nested to created a hierarchy of sub-pages. However,\n there can only be one root WikiPage per owner object, and all sub-pages are\n considered to be owned by the same object as the root page.\n <\/p>"
          },
          {
               "name": "WikiPage Services 2",
               "description": "<p>\n The Synapse <a href=\"${org.sagebionetworks.repo.model.v2.wiki.V2WikiPage}\">V2WikiPage<\/a> model\n object contains the data needed to render an end-user crafted web page. The\n Synapse Web Client will dynamically render a WikiPage into a combination of\n HTML, CSS and Javascript which is then finally rendered as a web page in the\n client's web browser.\n <\/p>\n <p>\n These services provide support for creating, reading, updating, and\n deleting (CRUD) the WikiPage model objects.\n <\/p>\n <p>\n WikiPages are composed of two major parts; a file that contains the markdown text \n and a list of file attachments. For example, to embed an image from an end-user's\n machine into a WikiPage, the image file must first be uploaded to Synapse as <a href=\"${org.sagebionetworks.repo.model.file.FileHandle}\">FileHandle<\/a> (see\n <a href=\"${org.sagebionetworks.file.controller.UploadController}\">File\n Services<\/a>). The FileHandle ID can then be added to a\n WikiPage.attachmentFileHandleIds list. See <a href=\"https://www.synapse.org\">www.synapse.org<\/a> for details on the\n supported markdown syntax. The markdown text is similarly uploaded as a\n FileHandle and its FileHandle ID is tracked by the WikiPage. \n <\/p>\n \n <p>\n WikiPages are not stand-alone objects, instead they are a component of\n another object such as an Entity or Evaluation. For example, when a WikiPage\n is created for an Entity, the Entity becomes the \"owner\" of the WikiPage.\n Access to the WikiPage is always tied to its owner. For example, to GET a\n WikiPage of an Entity, the caller must have read permission on the Entity.\n <\/p>\n <p>\n To navigate the hierarchy of WikiPages associated with an owner use the <a href=\"${GET.entity.ownerId.wikiheadertree2}\">GET\n /entity/{ownerId}/wikiheadertree2<\/a> method. The returned list of <a href=\"${org.sagebionetworks.repo.model.v2.wiki.V2WikiHeader}\">V2WikiHeaders<\/a> can\n be used to construct a full wiki hierarchy tree for that owner.\n <\/p>\n <p>\n To view a timeline of changes made to a WikiPage, use the \n <a href=\"${GET.entity.ownerId.wiki2.wikiId.wikihistory}\">GET/entity/{ownerId}\n /wiki2/{wikiId}/wikihistory<\/a> method. The returned list of <a href=\"${org.sagebionetworks.repo.model.v2.wiki.V2WikiHistorySnapshot}\">V2WikiHistorySnapshots\n <\/a> contain information about who modified the WikiPage and when the changes were made. \n <\/p>\n <p>\n Note: WikiPages can be nested to created a hierarchy of sub-pages. However,\n there can only be one root WikiPage per owner object, and all sub-pages are\n considered to be owned by the same object as the root page.\n <\/p>"
          }
     ],
     "paths": {
          "/auth/v1/.well-known/openid-configuration": {"get": {
               "tags": ["OpenID Connect Services"],
               "operationId": "get-/auth/v1/.well-known/openid-configuration",
               "parameters": [],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OIDConnectConfiguration"}}}
               }}
          }},
          "/auth/v1/oauth2/jwks": {"get": {
               "tags": ["OpenID Connect Services"],
               "operationId": "get-/auth/v1/oauth2/jwks",
               "parameters": [],
               "responses": {"200": {
                    "description": "the JSON Web Key Set",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.JsonWebKeySet"}}}
               }}
          }},
          "/auth/v1/oauth2/client": {
               "post": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "post-/auth/v1/oauth2/client",
                    "parameters": [],
                    "requestBody": {
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthClient"}}},
                         "required": true
                    },
                    "security": [{"bearerAuth": []}],
                    "responses": {"201": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthClient"}}}
                    }}
               },
               "get": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "get-/auth/v1/oauth2/client",
                    "parameters": [{
                         "name": "nextPageToken",
                         "in": "query",
                         "required": false,
                         "description": "returned along with a page of results, this is passed to \n the server to retrieve the next page.",
                         "schema": {"type": "string"}
                    }],
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthClientList"}}}
                    }}
               }
          },
          "/auth/v1/oauth2/client/secret/{id}": {"post": {
               "tags": ["OpenID Connect Services"],
               "operationId": "post-/auth/v1/oauth2/client/secret/{id}",
               "parameters": [{
                    "name": "id",
                    "in": "path",
                    "required": true,
                    "schema": {"type": "string"}
               }],
               "security": [{"bearerAuth": []}],
               "responses": {"201": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthClientIdAndSecret"}}}
               }}
          }},
          "/auth/v1/oauth2/client/{id}": {
               "get": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "get-/auth/v1/oauth2/client/{id}",
                    "parameters": [{
                         "name": "id",
                         "in": "path",
                         "required": true,
                         "description": "the ID of the client to retrieve",
                         "schema": {"type": "string"}
                    }],
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthClient"}}}
                    }}
               },
               "put": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "put-/auth/v1/oauth2/client/{id}",
                    "parameters": [{
                         "name": "id",
                         "in": "path",
                         "required": true,
                         "schema": {"type": "string"}
                    }],
                    "requestBody": {
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthClient"}}},
                         "required": true
                    },
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthClient"}}}
                    }}
               },
               "delete": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "delete-/auth/v1/oauth2/client/{id}",
                    "parameters": [{
                         "name": "id",
                         "in": "path",
                         "required": true,
                         "description": "the ID of the client to delete",
                         "schema": {"type": "string"}
                    }],
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {"description": "Void"}}
               }
          },
          "/auth/v1/oauth2/client/{id}/verificationPrecheck": {"put": {
               "tags": ["OpenID Connect Services"],
               "operationId": "put-/auth/v1/oauth2/client/{id}/verificationPrecheck",
               "parameters": [{
                    "name": "id",
                    "in": "path",
                    "required": true,
                    "schema": {"type": "string"}
               }],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthClient"}}},
                    "required": true
               },
               "security": [{"bearerAuth": []}],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthClientVerificationPrecheckResult"}}}
               }}
          }},
          "/auth/v1/oauth2/client/{id}/acl": {
               "get": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "get-/auth/v1/oauth2/client/{id}/acl",
                    "parameters": [{
                         "name": "id",
                         "in": "path",
                         "required": true,
                         "description": "the ID of the OpenID Client of interest",
                         "schema": {"type": "string"}
                    }],
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.AccessControlList"}}}
                    }}
               },
               "put": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "put-/auth/v1/oauth2/client/{id}/acl",
                    "parameters": [{
                         "name": "id",
                         "in": "path",
                         "required": true,
                         "schema": {"type": "string"}
                    }],
                    "requestBody": {
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.AccessControlList"}}},
                         "required": true
                    },
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.AccessControlList"}}}
                    }}
               }
          },
          "/auth/v1/oauth2/description": {"post": {
               "tags": ["OpenID Connect Services"],
               "operationId": "post-/auth/v1/oauth2/description",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OIDCAuthorizationRequest"}}},
                    "required": true
               },
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OIDCAuthorizationRequestDescription"}}}
               }}
          }},
          "/auth/v1/oauth2/consentcheck": {"post": {
               "tags": ["OpenID Connect Services"],
               "operationId": "post-/auth/v1/oauth2/consentcheck",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OIDCAuthorizationRequest"}}},
                    "required": true
               },
               "security": [{"bearerAuth": []}],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthConsentGrantedResponse"}}}
               }}
          }},
          "/auth/v1/oauth2/consent": {"post": {
               "tags": ["OpenID Connect Services"],
               "operationId": "post-/auth/v1/oauth2/consent",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OIDCAuthorizationRequest"}}},
                    "required": true
               },
               "security": [{"bearerAuth": []}],
               "responses": {"201": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthAuthorizationResponse"}}}
               }}
          }},
          "/auth/v1/oauth2/token": {"post": {
               "tags": ["OpenID Connect Services"],
               "operationId": "post-/auth/v1/oauth2/token",
               "parameters": [
                    {
                         "name": "verifiedOauthClientId",
                         "in": "header",
                         "required": true,
                         "schema": {"type": "string"}
                    },
                    {
                         "name": "grant_type",
                         "in": "query",
                         "required": true,
                         "description": "authorization_code or refresh_token",
                         "schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthGrantType"}
                    },
                    {
                         "name": "code",
                         "in": "query",
                         "required": false,
                         "description": "required if grant_type is authorization_code",
                         "schema": {"type": "string"}
                    },
                    {
                         "name": "redirect_uri",
                         "in": "query",
                         "required": false,
                         "schema": {"type": "string"}
                    },
                    {
                         "name": "refresh_token",
                         "in": "query",
                         "required": false,
                         "description": "required if grant_type is refresh_token",
                         "schema": {"type": "string"}
                    },
                    {
                         "name": "scope",
                         "in": "query",
                         "required": false,
                         "description": "only provided if grant_type is refresh_token",
                         "schema": {"type": "string"}
                    }
               ],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OIDCTokenResponse"}}}
               }}
          }},
          "/auth/v1/oauth2/userinfo": {
               "get": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "get-/auth/v1/oauth2/userinfo",
                    "parameters": [
                         {
                              "name": "Synapse-Authorization",
                              "in": "header",
                              "required": false,
                              "schema": {"type": "string"}
                         },
                         {
                              "name": "Accept",
                              "in": "header",
                              "required": false,
                              "schema": {"type": "string"}
                         }
                    ],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"type": "object"}}}
                    }}
               },
               "post": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "post-/auth/v1/oauth2/userinfo",
                    "parameters": [
                         {
                              "name": "Synapse-Authorization",
                              "in": "header",
                              "required": false,
                              "schema": {"type": "string"}
                         },
                         {
                              "name": "Accept",
                              "in": "header",
                              "required": false,
                              "schema": {"type": "string"}
                         }
                    ],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"type": "object"}}}
                    }}
               }
          },
          "/auth/v1/oauth2/introspect": {"post": {
               "tags": ["OpenID Connect Services"],
               "operationId": "post-/auth/v1/oauth2/introspect",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthTokenIntrospectionRequest"}}},
                    "required": true
               },
               "security": [{"bearerAuth": []}],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthTokenIntrospectionResponse"}}}
               }}
          }},
          "/auth/v1/oauth2/audit/grantedClients": {"get": {
               "tags": ["OpenID Connect Services"],
               "operationId": "get-/auth/v1/oauth2/audit/grantedClients",
               "parameters": [{
                    "name": "nextPageToken",
                    "in": "query",
                    "required": false,
                    "schema": {"type": "string"}
               }],
               "security": [{"bearerAuth": []}],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthClientAuthorizationHistoryList"}}}
               }}
          }},
          "/auth/v1/oauth2/audit/grantedClients/{clientId}/tokens": {"get": {
               "tags": ["OpenID Connect Services"],
               "operationId": "get-/auth/v1/oauth2/audit/grantedClients/{clientId}/tokens",
               "parameters": [
                    {
                         "name": "clientId",
                         "in": "path",
                         "required": true,
                         "schema": {"type": "string"}
                    },
                    {
                         "name": "nextPageToken",
                         "in": "query",
                         "required": false,
                         "schema": {"type": "string"}
                    }
               ],
               "security": [{"bearerAuth": []}],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthRefreshTokenInformationList"}}}
               }}
          }},
          "/auth/v1/oauth2/audit/tokens/{tokenId}/metadata": {
               "get": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "get-/auth/v1/oauth2/audit/tokens/{tokenId}/metadata",
                    "parameters": [{
                         "name": "tokenId",
                         "in": "path",
                         "required": true,
                         "schema": {"type": "string"}
                    }],
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthRefreshTokenInformation"}}}
                    }}
               },
               "put": {
                    "tags": ["OpenID Connect Services"],
                    "operationId": "put-/auth/v1/oauth2/audit/tokens/{tokenId}/metadata",
                    "parameters": [{
                         "name": "tokenId",
                         "in": "path",
                         "required": true,
                         "schema": {"type": "string"}
                    }],
                    "requestBody": {
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthRefreshTokenInformation"}}},
                         "required": true
                    },
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthRefreshTokenInformation"}}}
                    }}
               }
          },
          "/auth/v1/oauth2/token/{tokenId}/metadata": {"get": {
               "tags": ["OpenID Connect Services"],
               "operationId": "get-/auth/v1/oauth2/token/{tokenId}/metadata",
               "parameters": [
                    {
                         "name": "verifiedOauthClientId",
                         "in": "header",
                         "required": true,
                         "schema": {"type": "string"}
                    },
                    {
                         "name": "tokenId",
                         "in": "path",
                         "required": true,
                         "schema": {"type": "string"}
                    }
               ],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthRefreshTokenInformation"}}}
               }}
          }},
          "/auth/v1/oauth2/audit/grantedClients/{clientId}/revoke": {"post": {
               "tags": ["OpenID Connect Services"],
               "operationId": "post-/auth/v1/oauth2/audit/grantedClients/{clientId}/revoke",
               "parameters": [{
                    "name": "clientId",
                    "in": "path",
                    "required": true,
                    "schema": {"type": "string"}
               }],
               "security": [{"bearerAuth": []}],
               "responses": {"204": {"description": "Void"}}
          }},
          "/auth/v1/oauth2/audit/tokens/{tokenId}/revoke": {"post": {
               "tags": ["OpenID Connect Services"],
               "operationId": "post-/auth/v1/oauth2/audit/tokens/{tokenId}/revoke",
               "parameters": [{
                    "name": "tokenId",
                    "in": "path",
                    "required": true,
                    "schema": {"type": "string"}
               }],
               "security": [{"bearerAuth": []}],
               "responses": {"204": {"description": "Void"}}
          }},
          "/auth/v1/oauth2/revoke": {"post": {
               "tags": ["OpenID Connect Services"],
               "operationId": "post-/auth/v1/oauth2/revoke",
               "parameters": [{
                    "name": "verifiedOauthClientId",
                    "in": "header",
                    "required": true,
                    "schema": {"type": "string"}
               }],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthTokenRevocationRequest"}}},
                    "required": true
               },
               "responses": {"204": {"description": "Void"}}
          }},
          "/auth/v1/anonymousToken": {"get": {
               "tags": ["Authentication Services"],
               "operationId": "get-/auth/v1/anonymousToken",
               "parameters": [{
                    "name": "realm",
                    "in": "query",
                    "required": true,
                    "schema": {"type": "string"}
               }],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.AccessTokenResponse"}}}
               }}
          }},
          "/auth/v1/login2": {"post": {
               "tags": ["Authentication Services"],
               "operationId": "post-/auth/v1/login2",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.LoginRequest"}}},
                    "required": true
               },
               "responses": {"201": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.LoginResponse"}}}
               }}
          }},
          "/auth/v1/authenticatedOn": {"get": {
               "tags": ["Authentication Services"],
               "operationId": "get-/auth/v1/authenticatedOn",
               "parameters": [],
               "security": [{"bearerAuth": []}],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.AuthenticatedOn"}}}
               }}
          }},
          "/auth/v1/user/password/reset": {"post": {
               "tags": ["Authentication Services"],
               "operationId": "post-/auth/v1/user/password/reset",
               "parameters": [{
                    "name": "passwordResetEndpoint",
                    "in": "query",
                    "required": true,
                    "description": "the Portal's url prefix for handling password resets.",
                    "schema": {"type": "string"}
               }],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.Username"}}},
                    "required": true
               },
               "responses": {"204": {"description": "Void"}}
          }},
          "/auth/v1/user/changePassword": {"post": {
               "tags": ["Authentication Services"],
               "operationId": "post-/auth/v1/user/changePassword",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.ChangePasswordInterface"}}},
                    "required": true
               },
               "responses": {"204": {"description": "Void"}}
          }},
          "/auth/v1/termsOfUse2": {"post": {
               "tags": ["Authentication Services"],
               "operationId": "post-/auth/v1/termsOfUse2",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.TermsOfServiceSignRequest"}}},
                    "required": true
               },
               "responses": {"204": {"description": "Void"}}
          }},
          "/auth/v1/termsOfUse2/info": {"get": {
               "tags": ["Authentication Services"],
               "operationId": "get-/auth/v1/termsOfUse2/info",
               "parameters": [],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.TermsOfServiceInfo"}}}
               }}
          }},
          "/auth/v1/termsOfUse2/status": {"get": {
               "tags": ["Authentication Services"],
               "operationId": "get-/auth/v1/termsOfUse2/status",
               "parameters": [],
               "security": [{"bearerAuth": []}],
               "responses": {"200": {
                    "description": "The status of the terms of service for the current authenticated user.",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.TermsOfServiceStatus"}}}
               }}
          }},
          "/auth/v1/termsOfUse2/requirements": {"put": {
               "tags": ["Authentication Services"],
               "operationId": "put-/auth/v1/termsOfUse2/requirements",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.TermsOfServiceRequirements"}}},
                    "required": true
               },
               "security": [{"bearerAuth": []}],
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.TermsOfServiceInfo"}}}
               }}
          }},
          "/auth/v1/oauth2/authurl": {"post": {
               "tags": ["Authentication Services"],
               "operationId": "post-/auth/v1/oauth2/authurl",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthUrlRequest"}}},
                    "required": true
               },
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthUrlResponse"}}}
               }}
          }},
          "/auth/v1/oauth2/session2": {"post": {
               "tags": ["Authentication Services"],
               "operationId": "post-/auth/v1/oauth2/session2",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthValidationRequest"}}},
                    "required": true
               },
               "responses": {"200": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.LoginResponse"}}}
               }}
          }},
          "/auth/v1/oauth2/alias": {
               "post": {
                    "tags": ["Authentication Services"],
                    "operationId": "post-/auth/v1/oauth2/alias",
                    "parameters": [],
                    "requestBody": {
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthValidationRequest"}}},
                         "required": true
                    },
                    "security": [{"bearerAuth": []}],
                    "responses": {"201": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.principal.PrincipalAlias"}}}
                    }}
               },
               "delete": {
                    "tags": ["Authentication Services"],
                    "operationId": "delete-/auth/v1/oauth2/alias",
                    "parameters": [
                         {
                              "name": "provider",
                              "in": "query",
                              "required": true,
                              "description": "the OAuth provider through which the alias was associated",
                              "schema": {"type": "string"}
                         },
                         {
                              "name": "alias",
                              "in": "query",
                              "required": true,
                              "description": "the alias for the user given by the provider",
                              "schema": {"type": "string"}
                         }
                    ],
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {"description": "Void"}}
               }
          },
          "/auth/v1/oauth2/account2": {"post": {
               "tags": ["Authentication Services"],
               "operationId": "post-/auth/v1/oauth2/account2",
               "parameters": [],
               "requestBody": {
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.oauth.OAuthAccountCreationRequest"}}},
                    "required": true
               },
               "responses": {"201": {
                    "description": "Auto-generated description",
                    "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.LoginResponse"}}}
               }}
          }},
          "/auth/v1/personalAccessToken": {
               "post": {
                    "tags": ["Authentication Services"],
                    "operationId": "post-/auth/v1/personalAccessToken",
                    "parameters": [{
                         "name": "Synapse-Authorization",
                         "in": "header",
                         "required": false,
                         "schema": {"type": "string"}
                    }],
                    "requestBody": {
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.AccessTokenGenerationRequest"}}},
                         "required": true
                    },
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.AccessTokenGenerationResponse"}}}
                    }}
               },
               "get": {
                    "tags": ["Authentication Services"],
                    "operationId": "get-/auth/v1/personalAccessToken",
                    "parameters": [{
                         "name": "nextPageToken",
                         "in": "query",
                         "required": false,
                         "schema": {"type": "string"}
                    }],
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {
                         "description": "Auto-generated description",
                         "content": {"application/json": {"schema": {"$ref": "#/components/schemas/org.sagebionetworks.repo.model.auth.AccessTokenRecordList"}}}
                    }}
               }
          },
          "/auth/v1/personalAccessToken/{id}": {
               "get": {
                    "tags": ["Authentication Services"],
                    "operationId": "get-/auth/v1/personalAccessToken/{id}",
                    "parameters": [{
                         "name": "id",
                         "in": "path",
                         "required": true,
                         "description": "The unique ID of the token, which is the unique ID (the \"jti\" claim) contained in the JWT",
                         "schema": {"type": "number"}
                    }],
                    "security": [{"bearerAuth": []}],
                    "responses": {"200": {
                         "description": "Auto-generated description",
[...]
